Overview
========

This subordinate charm runs an Ansible playbook, in a git repository, against localhost.

The charm performs the following operations, in the context of the main charm:

- clone a git repository, which should contain an Ansible playbook (`git_*` configuration options)

- prepare an Ansible inventory and execute the cloned playbook (`ansible_*` configuration options)

- check at regular intervals if the playbook needs to be executed again (`check_*` configuration options)

  
The rationale behind this charm is that:

- the idempotency provided by Ansible seems to match the idempotency required by Juju charm hook implementations

- there are several ready to go Ansible playbooks available online (and inside organizations)

- DevOps which prefer Ansible over scripting are facilitated.

Ansible charm users should be aware that race conditions may arise if the main charm and the subordinate Ansible charm modify the same resources.


Usage
=====

Usage example:

    juju deploy cs:ubuntu
    juju deploy cs:ansible simpleansible
    juju config simpleansible git_repo="https://git.garr.it/clauz/simpleansible.git"
    juju config simpleansible ansible_playbook_yaml="main.yaml" 
    juju add-relation ubuntu ansible


Contact Information
===================

Consortium GARR

cloud-support@garr.it
